#ifndef ZBDefMsgsH
#define ZBDefMsgsH
/*
  ZMDefsMsgs.h - Header file with default messages and compressed tables
  TZipBuilder VCL by Chris Vleghert and Eric W. Engler
  v1.79
  Copyright (C) 2005  Roger Aelbrecht
 
  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
 
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License (licence.txt) for more details.
 
  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 
  contact: Zipbuilder AT drehoeksw DOT net
  DelphiZip maillist subscribe at http://www.geocities.com/SiliconValley/Orchard/8607/
  updates: http://www.drehoeksw.net
 
  last modified 24/12/2005 15:48:44
---------------------------------------------------------------------------*/
 
 
 
struct TZipResRec
{
    Word i;
    const char* s;
};
 
#ifndef USE_COMPRESSED_STRINGS
TZipResRec ResTable[] = {
{DT_Language , "US: default"},
{DT_Author , "R.Peters"},
{DT_Desc , "Language Neutral"},
{GE_FatalZip , "Fatal Error in DLL: abort exception"},
{GE_NoZipSpecified , "Error - no zip file specified!"},
{GE_NoMem , "Requested memory not available"},
{GE_WrongPassword , "Error - passwords do NOT match\nPassword ignored"},
{GE_CopyFile , "Copying: "},
{GE_Except , "Exception in Event handler "},
{GE_Reentered , "Was busy, Instructions may have been lost!"},
{GE_Busy , " Busy, Please wait"},
{GE_Inactive , "not Active"},
{GE_RangeError , "Index (%d) outside range 1..%d"},
{GE_TempZip , "Temporary zipfile: %s"},
{GE_WasBusy , "Busy + %s"},
{GE_EventEx , "Exception in Event "},
{GE_DLLAbort , "DLL Error - Aborting"},
{GE_DLLBusy , "DLL Error - Busy"},
{GE_DLLCancel , "DLL Error - User Cancelled"},
{GE_DLLMem , "DLL Error - Not enough memory"},
{GE_DLLStruct , "DLL Error - Invalid structure"},
{GE_DLLEvent , "DLL Error - Exception in handler "},
{GE_DLLCritical , "critical DLL Error %d"},
{GE_Unknown , " Unknown error %d"},
{GE_Skipped , "Skipped %s %d"},
{RN_ZipSFXData , "Error while copying the SFX header"},
{RN_NoRenOnSpan , "Rename is not implemented for a spanned zip file"},
{RN_ProcessFile , "Processing: "},
{RN_RenameTo , " renamed to: "},
{RN_InvalidDateTime , "Invalid date/time argument for file: "},
{PW_UnatAddPWMiss , "Error - no add password given"},
{PW_UnatExtPWMiss , "Error - no extract password given"},
{PW_Caption , "Password"},
{PW_MessageEnter , "Enter Password "},
{PW_MessageConfirm , "Confirm Password "},
{PW_ForFile , " for file: "},
{CF_SourceIsDest , "Source archive is the same as the destination archive!"},
{CF_OverwriteYN , "Overwrite file '%s' in '%s' ?"},
{CF_CopyFailed , "Copying a file from '%s' to '%s' failed"},
{CF_SourceNotFound , "File '%s' is not present in '%s'!"},
{CF_SFXCopyError , "Error while copying the SFX data"},
{CF_DestFileNoOpen , "Destination zip archive could not be opened!"},
{CF_NoCopyOnSpan , "CopyZippedFiles is not implemented for a spanned zip file"},
{LI_ReadZipError , "Seek error reading Zip archive!"},
{LI_ErrorUnknown , "Unknown error in List() function\n"},
{LI_WrongZipStruct , "Warning - Error in zip structure!"},
{LI_GarbageAtEOF , "Warning - Garbage at the end of the zipfile!"},
{LI_FileTooBig , "File larger than 4GB"},
{LI_MethodUnknown , "Unknown Compression Method"},
{ZB_Yes , "&Yes"},
{ZB_No , "&No"},
{ZB_OK , "&OK"},
{ZB_Cancel , "&Cancel"},
{ZB_Abort , "&Abort"},
{ZB_Retry , "&Retry"},
{ZB_Ignore , "&Ignore"},
{ZB_CancelAll , "CancelAll"},
{ZB_NoToAll , "NoToAll"},
{ZB_YesToAll , "YesToAll"},
{AD_NothingToZip , "Error - no files to zip!"},
{AD_UnattPassword , "Unattended action not possible without a password"},
{AD_NoFreshenUpdate , "AddFreshen or AddUpdate not possible on a spanned archive"},
{AD_AutoSFXWrong , "Error %.1d occurred during Auto SFX creation."},
{AD_InIsOutStream , "Input stream may not be set to the output stream"},
{AD_InvalidName , "Wildcards are not allowed in Filename or file specification"},
{AD_NoDestDir , "Destination directory '%s' must exist!"},
{DL_NothingToDel , "Error - no files selected for deletion"},
{DL_NoDelOnSpan , "Delete Files from archive is not implemented for a spanned zip file"},
{EX_FatalUnZip , "Fatal Error in UnzDLL.DLL: abort exception"},
{EX_UnAttPassword , "Warning - Unattended Extract: possible not all files extracted"},
{EX_NoExtrDir , "Extract directory '%s' must exist"},
{LD_NoDll , "Failed to load %s"},
{LD_BadDll , "Unable to load %s - It is old or corrupt"},
{LD_DllLoaded , "Loaded %s"},
{LD_DllUnloaded , "Unloaded %s"},
{SF_NoZipSFXBin , "Error: SFX stub '%s' not found!"},
{SF_InputIsNoZip , "Error: input file is not a zip file"},
{SF_NoSFXSupport , "SFX Functions not supported"},
{SF_MsgTooLong , "SFX Message string exceeds 255 characters!"},
{SF_DefPathTooLong , "SFX Default path exceeds 255 characters!"},
{SF_DlgTitleTooLong , "SFX Dialog title exceeds 255 characters!"},
{SF_CmdLineTooLong , "SFX Command line exceeds 255 characters!"},
{SF_FBkPathTooLong , "SFX Fallback path exceeds 255 characters!"},
{CZ_NoExeSpecified , "Error - no .EXE file specified"},
{CZ_InputNotExe , "Error: input file is not an .EXE file"},
{CZ_SFXTypeUnknown , "Error determining the type of SFX archive"},
{CZ_WrongConvert , "Can only convert ZIP to EXE or EXE to ZIP"},
{CZ_UnknownHeader , "Unknown SFX header format in %s"},
{CZ_BrowseError , "Error while browsing resources."},
{CZ_NoExeResource , "No resources found in executable."},
{CZ_ExeSections , "Error while reading executable sections."},
{CZ_NoExeIcon , "No icon resources found in executable."},
{CZ_NoIcon , "No icon found."},
{CZ_NoCopyIcon , "Cannot copy icon."},
{CZ_NoIconFound , "No matching icon found."},
{DS_NoInFile , "Input file does not exist"},
{DS_FileOpen , "Zip file could not be opened"},
{DS_NotaDrive , "Not a valid drive: %s"},
{DS_DriveNoMount , "Drive %s is NOT defined"},
{DS_NoVolume , "Volume label could not be set"},
{DS_NoMem , "Not enough memory to display MsgBox"},
{DS_Canceled , "User canceled operation"},
{DS_FailedSeek , "Seek error in input file"},
{DS_NoOutFile , "Creation of output file failed"},
{DS_NoWrite , "Write error in output file"},
{DS_EOCBadRead , "Error while reading the End Of Central Directory"},
{DS_LOHBadRead , "Error while reading a local header"},
{DS_CEHBadRead , "Error while reading a central header"},
{DS_LOHWrongSig , "A local header signature is wrong"},
{DS_CEHWrongSig , "A central header signature is wrong"},
{DS_LONameLen , "Error while reading a local file name"},
{DS_CENameLen , "Error while reading a central file name"},
{DS_LOExtraLen , "Error while reading a local extra field"},
{DS_CEExtraLen , "Error while reading a central extra field"},
{DS_DataDesc , "Error while reading/writing a data descriptor area"},
{DS_ZipData , "Error while reading zipped data"},
{DS_CECommentLen , "Error while reading a file comment"},
{DS_EOArchComLen , "Error while reading the archive comment"},
{DS_ErrorUnknown , "UnKnown error in function ReadSpan(), WriteSpan(), ChangeFileDetails() or CopyZippedFiles()\n"},
{DS_NoUnattSpan , "Unattended disk spanning not implemented"},
{DS_EntryLost , "A local header not found in internal structure"},
{DS_NoTempFile , "Temporary file could not be created"},
{DS_LOHBadWrite , "Error while writing a local header"},
{DS_CEHBadWrite , "Error while writing a central header"},
{DS_EOCBadWrite , "Error while writing the End Of Central Directory"},
{DS_ExtWrongSig , "Error while reading a Extended Local signature"},
{DS_NoDiskSpace , "This disk has not enough free space available"},
{DS_InsertDisk , "Please insert last disk"},
{DS_InsertVolume , "Please insert disk volume %.1d of %.1d"},
{DS_InDrive , "\nin drive: %s"},
{DS_NoValidZip , "This archive is not a valid Zip archive"},
{DS_FirstInSet , "This is the first disk in a backup set,\nplease insert the last disk of this set"},
{DS_NotLastInSet , "This is the %dth disk in a backup set,\nplease insert the last disk of this set"},
{DS_AskDeleteFile , "There is already a file %s\nDo you want to overwrite this file"},
{DS_AskPrevFile , "ATTENTION: This is previous disk no %d!!!\nAre you sure you want to overwrite the contents"},
{DS_NoSFXSpan , "Error - Self extracting archives(.exe) can not be spanned"},
{DS_CEHBadCopy , "Error while copying a filename of a CEH structure"},
{DS_EOCBadSeek , "Seek error while skipping a EOC structure"},
{DS_EOCBadCopy , "Error while copying the zip archive comment"},
{DS_FirstFileOnHD , "This is the first file in a backup set,\nplease choose the last file of this set"},
{DS_InsertAVolume , "Please insert disk volume %.1d"},
{DS_CopyCentral , "Central directory"},
{DS_NoDiskSpan , "DiskSpanning not supported"},
{DS_UnknownError , "Unknown Error"},
{DS_NoRenamePart , "Last part left as : %s"},
{DS_NotChangeable , "Cannot write to %s"},
{FM_Erase , "Erase %s"},
{FM_Confirm , "Confirm"},
{CD_NoCDOnSpan , "ChangeFileDetails is not implemented for a spanned zip file"},
{CD_NoEventHndlr , "No Event Handler found to Change File Details"},
{CD_LOExtraLen , "Error while writing a local extra field"},
{CD_CEExtraLen , "Error while writing a central extra field"},
{CD_CEComLen , "Error while writing a file comment"},
{CD_CEHDataSize , "The combined length of CEH + FileName + FileComment + ExtraData exceeds 65535"},
{CD_Changing , "Changing details of: "},
{CD_DuplFileName , "Duplicate Filename: %s"},
{CD_NoProtected , "Cannot change details of Excrypted file"},
{CD_InvalidFileName , "Invalid Filename: '%s'"},
{CD_NoChangeDir , "Cannot change path"},
{CD_FileSpecSkip , "Filespec '%s' skipped"},
{DU_InvalidName , "Invalid name '%s'"},
{DU_WrongMethod , "unsupported compression for '%s'"},
{PR_Archive , "*Resetting Archive bit"},
{PR_CopyZipFile , "*Copying Zip File"},
{PR_SFX , "*SFX"},
{PR_Header , "*??"},
{PR_Finish , "*Finalising"},
{PR_Copying , "*Copying"},
{PR_CentrlDir , "*Central Directory"},
{PR_Checking , "*Checking"},
{PR_Loading , "*Loading Directory"},
{PR_Joining , "*Joining split zip file"},
{PR_Splitting , "*Splitting zip file"},
{DZ_Skipped , "Filespec '%s' skipped"},
{DZ_InUse , "Can not open in-use file '%s'"},
{DZ_Refused , "not permitted to open '%s'"},
{DZ_NoOpen , "Can not open '%s'"},
{DZ_NoFiles , "no files found"},
{DZ_SizeChanged , "size of '%s' changed"},
{DZ_InvalidName , "'%s' is not valid name"},
{DZ_TooBig , "file is too big"},
{WZ_DropDirOnly , "Dropping %d empty directory entries"},
{WZ_NothingToWrite , "Nothing to write"},
{TM_Erasing , "EraseFloppy - Removing %s"},
{TM_Deleting , "EraseFloppy - Deleting %s"},
{TM_GetNewDisk , "Trace : GetNewDisk Opening: %s"},
{TM_SystemError , "System error: %d"},
};
#endif
 
#ifdef USE_COMPRESSED_STRINGS
const unsigned CompBlock[] = {
  0x10310409, 0x53550002, 0x00003518, 0xF0F00035, 0xFFF0F020, 
  0xFFF3F6FF, 0x02BCABFD, 0xF706F5F2, 0x001178F0, 0x3000DF00, 
  0x00040910, 0xDF000B05, 0x00530055, 0x64F0F33A, 0x0065FF00, 
  0x00610066, 0x6CFF0075, 0x08007400, 0xD7005200, 0x3B50002E, 
  0x003B7400, 0x73DF0072, 0x4C001000, 0x006E003F, 0x00416755, 
  0x65006161, 0x3B4EF0F3, 0x4575D500, 0x003F7200, 0x2302006C, 
  0x3F467500, 0x02777400, 0x55450020, 0x00727700, 0x2000556F, 
  0x005F6900, 0x440020D7, 0x354C005B, 0xF5006102, 0x74029362, 
  0x0065F0F3, 0x63D50078, 0x4570003B, 0x00936900, 0x1ED5006E, 
  0xF32D0A8D, 0x00936EF0, 0x7A550020, 0xF3700099, 0x009966F0, 
  0x5502696C, 0x6500BD73, 0xE76900B9, 0x00396502, 0x00C72155, 
  0x71003B52, 0x57650041, 0x0152AA00, 0x6DF0F364, 0x936D003B, 
  0xD71C7902, 0x6101B204, 0x003F7600, 0x01AA01EA, 0x2F01ECD2, 
  0x00BD0DC9, 0x73005761, 0x9377C500, 0x00576402, 0x01DC0138, 
  0x4FE7004E, 0x12195400, 0x00630184, 0x0A00A368, 0x1B58004D, 
  0xD9670198, 0xFF2E7202, 0x43000902, 0x25700093, 0x45019A10, 
  0x1B023567, 0x0DB8008D, 0x33450598, 0x5F652910, 0x6801B200, 
  0xEB64025D, 0x57019602, 0x5757002A, 0x00AB2012, 0x97005775, 
  0xF32C0079, 0x005F49F0, 0x02721112, 0xBF630041, 0x78116606, 
  0xE0112611, 0xAA11D611, 0xD76511F8, 0x00432012, 0x2112116F, 
  0xF312002B, 0x18FB42F0, 0x5802EB50, 0x016A4A11, 0x74123577, 
  0x152A1081, 0xD2241141, 0x051E11D6, 0x78013A22, 0x0028F0F3, 
  0x00392555, 0x6FF0F329, 0x99730271, 0x013AA200, 0x60027520, 
  0x31016A01, 0x522E004B, 0x73152291, 0x70111E10, 0x23610293, 
  0x03E06814, 0x013605E8, 0xF0005725, 0x71091201, 0xA30D1F79, 
  0x20254A10, 0x24E52B00, 0x1DB91321, 0x14D91DC9, 0x9F140500, 
  0x120B8C04, 0xAB4101D6, 0x1013AE06, 0x06D13D51, 0x1A49254A, 
  0x06D13D7B, 0x96225D55, 0x025D4301, 0x6C01BA3A, 0x006402EB, 
  0xD13D9D1D, 0x2B4E1106, 0x9A11D814, 0x107F6721, 0x3DD21B1A, 
  0x0607D088, 0x6C113421, 0x01F022A1, 0x8275270C, 0x0F21129D, 
  0x2206D14D, 0xE037323D, 0xB90A151D, 0x22677200, 0x8800B969, 
  0x964D4C03, 0x2192BA01, 0x6E32B311, 0x02D96B00, 0x029B2877, 
  0x49AE0154, 0x6B00330D, 0x01F402E1, 0xE8111838, 0x0043B421, 
  0xF6F1F600, 0x7A51011A, 0x5D1A2DFB, 0x8D225624, 0x107F770A, 
  0x6305EAAA, 0x45201AA7, 0x02696800, 0x0081E253, 0x5A427B58, 
  0x72013A21, 0x07823000, 0x003F6E12, 0x0198111C, 0x152A1166, 
  0x22C5A069, 0x111C01EC, 0x131611DA, 0x61049366, 0x5E04EF24, 
  0x14156E01, 0x4D0C0DE0, 0x88019200, 0x115A01BA, 0xA70D17AE, 
  0x18577E22, 0x935C7411, 0x00013600, 0x2AED4C00, 0x045D0B7B, 
  0x4D282091, 0x42028364, 0x8401C011, 0x2021CE53, 0x55A20162, 
  0x29DC57AE, 0x531D5724, 0x4804D94D, 0x11185172, 0x61201D56, 
  0x6E237C00, 0x8C001003, 0xB603DA6D, 0x12037401, 0xB86DA821, 
  0x0DF1F06B, 0x001D8308, 0xA6008D0F, 0x10019653, 0xB920297D, 
  0x6E11A640, 0x1B7202E7, 0x507D2C10, 0x032C1118, 0x23E26D6A, 
  0x7D0A1160, 0x98126D23, 0x00333676, 0xB972219A, 0x7E635802, 
  0x237C0811, 0x555E5588, 0xF4568173, 0x3A555E13, 0x1112A001, 
  0x0184019A, 0x7BB8352E, 0x4F400D21, 0x7212D542, 0x4392105D, 
  0x07E8016A, 0x0922E727, 0x36069727, 0x80353F87, 0x53B61BA6, 
  0x660107E8, 0x714E0291, 0x610A8736, 0x013E8934, 0x020203EA, 
  0x8D2D4611, 0x00BD5D87, 0x215E119E, 0x408213DA, 0x0C8B218B, 
  0x5D525D42, 0x63465962, 0x20010261, 0x2F7DEF44, 0xB855CC34, 
  0x4291007D, 0x1118C001, 0x2132152A, 0x01F42198, 0x002153C4, 
  0x16A53905, 0xA448E35A, 0x8A116685, 0xA85D9A5D, 0x5DBA5DAA, 
  0x98655DCA, 0x2AED9678, 0x7D8F487E, 0xF0F0AD1E, 0x3400331F, 
  0x4CCB6B21, 0x72119E20, 0x8C950851, 0x219D4893, 0x4DBE1003, 
  0x9A49CE94, 0x92A34C03, 0x96208F74, 0x41486621, 0xC031C400, 
  0x10030A05, 0x5F7211F2, 0x95084000, 0xAD864360, 0x4D3895E6, 
  0xB72C4148, 0x02D50AAD, 0x6222CD47, 0x01840665, 0x11D8970E, 
  0x6F111822, 0x970E003D, 0x4F212BD6, 0xE087A430, 0x615C113A, 
  0x911013EA, 0x0020015E, 0xB00F0234, 0x74309B42, 0xC611A6AD, 
  0xA083C821, 0x33304A21, 0x68024F4D, 0x41F80093, 0xE2204900, 
  0x0F7F0912, 0xE0BDD6AD, 0x260004B6, 0x0F59008B, 0xB0F10312, 
  0xB1FA31EC, 0x4B004F4F, 0xB0F10700, 0x330039C0, 0x09121A10, 
  0x00BDC780, 0x6AB0F106, 0x14C13C37, 0x01741108, 0x49C20979, 
  0x11A41897, 0x419537C2, 0xEB0732C9, 0x00935432, 0x5008C376, 
  0xC782B4F3, 0xC3A4CD9D, 0x842AED24, 0xD204CD2B, 0x18C8DECD, 
  0x04D96DC7, 0x73CA05E8, 0x210107DC, 0xB18020B5, 0x01520184, 
  0x11182386, 0x2E0063E6, 0x3E87BE35, 0x3E21A021, 0x68216213, 
  0x48B1AE21, 0x93D00172, 0x75396DEE, 0x4661A420, 0x601084C7, 
  0x94019C51, 0x55D38603, 0x654600BD, 0x5450DD44, 0xD48500D9, 
  0x9CAD609D, 0xC3852AED, 0x00D524CD, 0xB52E4BAA, 0x63B33220, 
  0x414400B9, 0x38139E10, 0x08414401, 0x02714195, 0x556601DC, 
  0x5A419048, 0x2E05C021, 0x22050121, 0x00D46970, 0x215A230A, 
  0x2520714E, 0x215E9B66, 0x01DCB322, 0x9A951090, 0x82ED7C23, 
  0x10F13B51, 0x406401EA, 0x15624299, 0xD9B221CE, 0x213C0178, 
  0x80141577, 0x85A4039A, 0x7B6E5780, 0x419A0DF0, 0x802605C0, 
  0x362D9D29, 0x119EA150, 0x15222112, 0x486D8736, 0x05B212FB, 
  0xDE21A398, 0xF2F4A4CD, 0x8B094AFD, 0xF0F0ED07, 0xFFCDEF26, 
  0x30E4A5CD, 0x211220F1, 0x013A9BC4, 0x05C0F130, 0x18F25143, 
  0x016A0003, 0x87729998, 0x9DA49D4A, 0x9DC49DB4, 0xE4B8DDD8, 
  0xB599F49D, 0x3200000D, 0x04912AED, 0x08E2FDC3, 0x2280A32A, 
  0xCC419E93, 0x0543BCAD, 0x2E44A17A, 0x11B444A1, 0x336E113C, 
  0x6802F390, 0xADFB3E4B, 0xDD2434B1, 0x41649162, 0xB44067E2, 
  0xF4DDBE11, 0xDEDB04ED, 0x00917C6B, 0xE0D062C5, 0x7AFD6A6B, 
  0x74FD8AFD, 0xBA000DE2, 0x9ACA1D22, 0x2D3A0DD7, 0xF3112240, 
  0x10859A02, 0xF1028584, 0x23E65172, 0x90145D28, 0x102D6015, 
  0x432443F0, 0x013C0364, 0x8A945F6F, 0x8A9100A3, 0x6B751102, 
  0xA0950942, 0x47EA2368, 0x125DB00B, 0x47EA2566, 0x031A2340, 
  0x04A4C91E, 0x50302D2B, 0x17FDD755, 0x9AD1E280, 0x044306D5, 
  0xB9389370, 0x7484C334, 0x96C14693, 0x00A3E6E1, 0x41F2A3C0, 
  0xB3A06562, 0x916E6304, 0x1734F302, 0xF2917C1C, 0x35003241, 
  0x81FE30A9, 0xBA0A417E, 0x40F17217, 0x00A03121, 0x66717C17, 
  0xF1560255, 0x34C04175, 0x80956689, 0x7EA1A601, 0xC7230191, 
  0xC4F10E3C, 0x5AF72CE5, 0x9C01880B, 0x591B250D, 0xACA546E6, 
  0xBF73095C, 0x04118622, 0x917CC146, 0xA8E6592A, 0x18D1C2B1, 
  0x083968B5, 0x3DA63D96, 0x59283DB6, 0x960126E6, 0x40915E81, 
  0xB16E65EA, 0x4DBC4DAC, 0x49DC4DCC, 0x0102F969, 0x24940B6F, 
  0x00F33081, 0x205D105D, 0x0035D65D, 0xE192B390, 0x613EB330, 
  0x5D52332E, 0x3BB85D62, 0x484F2911, 0xB11613A0, 0xF6A23963, 
  0x285DAA4D, 0x35BE5DBA, 0x81E22B40, 0x3D07AA7A, 0x1E29684E, 
  0x649B3D1B, 0x5800FF2E, 0xFD2A00FF, 0x7CF73A04, 0x4D072591, 
  0x4D274D17, 0xF110D235, 0x656D7642, 0x1900A09F, 0x73260114, 
  0x40F20D6D, 0x31629D08, 0x35429192, 0x0B4A35D6, 0x92C40D29, 
  0x956CD3CE, 0x6E9100E2, 0xD16C8419, 0x209D025A, 0xD8868350, 
  0xD8A38A65, 0x60838665, 0x7F1F0173, 0xE8E659BD, 0x2823E471, 
  0x92A18AF3, 0x87D250E1, 0x39C621D6, 0x87628BF2, 0xB29D77A2, 
  0xC8A3C220, 0x4C915C83, 0x2EF15401, 0xB1FE80E3, 0x3A7DFA00, 
  0x0C35FC05, 0x001136F5, 0x7AD16A01, 0x9D2E0125, 0x827DD2A0, 
  0x3EAD4A65, 0x0065848D, 0x45620203, 0x0CB4FB2E, 0x167350F1, 
  0x368D268D, 0x8B46128D, 0xF98DA70E, 0x204F2E38, 0x9566C30E, 
  0x8821B850, 0x7287AC91, 0xCA1D4EE1, 0x036D43AB, 0x84111700, 
  0xD3EE73BE, 0x8DFCA3C2, 0x8714930C, 0x909D979D, 0x47B0AA01, 
  0xB09DC69D, 0x771909C0, 0x646780EA, 0xF3F4A089, 0xF792E59A, 
  0xA6591C01, 0x21B86780, 0xE12C41EE, 0x335AEB9A, 0x15D3E252, 
  0xD56CB2FD, 0x6902F976, 0x4610E43D, 0x26D1F4E1, 0x1721D611, 
  0xA5640025, 0x5A8A2592, 0xC0054E03, 0x40041154, 0x1DD3E2F1, 
  0xA956000B, 0xF41F7522, 0x338CB160, 0x9C42AD20, 0x400574ED, 
  0xD196A54A, 0xF36781CE, 0x01720052, 0xE196333A, 0x81747368, 
  0xB160018C, 0x4D55E196, 0x7B672095, 0x10376FB0, 0x40105D17, 
  0x23B4F1FA, 0x0396C710, 0xF75E355A, 0x12E00FA0, 0xB7B1B7BC, 
  0x53C0ED9D, 0x51EA52FD, 0x0408611E, 0x846DAC1B, 0x00231E61, 
  0x3542EB64, 0x8008EBBE, 0x5641EA67, 0xE0D91A25, 0x032EE146, 
  0xC204BD84, 0x306580BD, 0x8D658D55, 0x00FF7D05, 0x4F055394, 
  0x73433245, 0xFC117A04, 0xDE513801, 0x1F22011B, 0x51CD2FCD, 
  0x02018816, 0x6AE1E2F1, 0x79AA02C1, 0x91CD8124, 0x3ACAA1CD, 
  0xAAC96211, 0x85212179, 0xACCDACD0, 0x67D15479, 0xE144145F, 
  0x7767BE12, 0x11541203, 0xF4D21123, 0x04DD22CD, 0xDD42DD32, 
  0xD26A9B67, 0x14CDE2CD, 0x026780DB, 0x9D27F51C, 0xE7DDADDD, 
  0xD6CA61CD, 0x40DDE6DD, 0xED06DDF6, 0x17B4D916, 0xA1BA637E, 
  0x206CE764, 0xED56ED46, 0xED72ED16, 0x8932E382, 0x22ED99ED, 
  0x492F1451, 0x5A5148D2, 0x04F564E9, 0x73010312, 0x316CF043, 
  0x0582113E, 0x7DD0E3A2, 0x7400EDEC, 0x5C433E87, 0xF6A35E31, 
  0x52CD8003, 0x00EB58FD, 0x518EAB18, 0xED380374, 0xCD3EFD92, 
  0xFDB87D2C, 0xCA06026B, 0xBD67B209, 0x125D5C00, 0x78974BE1, 
  0x617EBDF6, 0x00204B5A, 0x846F2A52, 0x28048D53, 0xCB2C703B, 
  0x12B7EA00, 0x11430D76, 0x65115462, 0x63824057, 0x880841E6, 
  0x72618281, 0x76732921, 0x9126518A, 0x7208A310, 0xC005ACF3, 
  0x26730A03, 0xB30C1D64, 0x8A1051EA, 0x52931661, 0x69453215, 
  0xB112508F, 0x7A04A1FA, 0x2E619833, 0x7CA9DD11, 0x87D43DF2, 
  0xFA9081D8, 0x6AE13063, 0x7543A0C1, 0xD38412E1, 0xA0910023, 
  0x437AA1FA, 0x3164F1FA, 0xADC6AD18, 0xAE0013BE, 0x826198B5, 
  0x06F7D8FD, 0xBAED62FD, 0x001DEECD, 0xEDAC1DFE, 0x73B0DD60, 
  0x2D40CD1E, 0xCD48F70C, 0x68CD5880, 0xD6C578CD, 0xDC2D7E61, 
  0x45270EFD, 0xFEE2C7A4, 0xE8674C09, 0x6B65DD78, 0xEB405460, 
  0x0A610422, 0xF8611217, 0x66A9EC9B, 0x8640129D, 0xF6611865, 
  0x82A156F3, 0x17858A61, 0x8400708D, 0xBE315261, 0x58416663, 
  0x0AA1B475, 0x511708A1, 0xA73D9726, 0x76170A3A, 0x8525AAA7, 
  0x41311190, 0xFC7122B4, 0x00EF0D35, 0xAD6283D8, 0xF0C77301, 
  0xFDFA373C, 0xAB546DC2, 0x4B3CA510, 0x3EA19000, 0xA4D38C35, 
  0x20619425, 0xD83BE061, 0x415A2483, 0x137555E4, 0x2CA3DAA2, 
  0x133200EF, 0x5A3DCE00, 0xB425A473, 0x2051EA3D, 0x8C21A473, 
  0xA3DA12D3, 0xA34D814E, 0x70AF2526, 0x4DA653F2, 0xC64DB680, 
  0xE64DD64D, 0x064DF64D, 0x3D57165D, 0x2E323B00, 0xC04748B1, 
  0x0225F6E1, 0x70FBACB1, 0xC90A09A1, 0x79718620, 0x21E83263, 
  0x53889116, 0x6F718682, 0x25947455, 0x353E7312, 0xD7006580, 
  0x3A03E800, 0x0D27B399, 0x55AA5900, 0xA09154D0, 0x49521F45, 
  0x544EA08F, 0x5D2262A7, 0x76129D70, 0x4175B2B5, 0x61C8143C, 
  0xA9215338, 0xD0550A62, 0x55FCD386, 0xD6837301, 0x6D0C5DFC, 
  0x15BE6D1C, 0x21BE133C, 0x39007317, 0x9F2D2ADD, 0xC0A1BA72, 
  0xE7C620B1, 0x35000362, 0x01EA4974, 0xC484DD2E, 0xB3341001, 
  0x17141DCC, 0xDD311140, 0x261AB92D, 0xFDA4A091, 0xE530218E, 
  0x415A4504, 0x48708543, 0x9D1D8D44, 0xBD792912, 0x72D37D8B, 
  0x22F46D6B, 0x134F2BFE, 0x9E7DD490, 0x7D852B11, 0x9B007D95, 
  0x40F46B2D, 0x800D087D, 0xB84D904D, 0x10E72633, 0x5D5E5D4E, 
  0x91665D6E, 0x78004F6F, 0x085D8C53, 0x5DA8E924, 0xC71EA3DA, 
  0xE73DD73D, 0x113AF73D, 0xE72DB911, 0x1ACB72F2, 0x110E22C9, 
  0x1CA00590, 0x7063C01D, 0x3E0150F1, 0x02F30D13, 0x083F046B, 
  0x1B16873E, 0x78559630, 0x9835AE01, 0x435608A1, 0xA56CA18A, 
  0xA4907312, 0xEC435493, 0x63A29A6B, 0x00B57073, 0x5C604C3E, 
  0x4B88B6B7, 0x6EAD626D, 0x823D08A8, 0x412C953C, 0x02CDAA07, 
  0x6D44996E, 0x4588B270, 0x5314BDAA, 0x34A0B4AD, 0x6B6970E9, 
  0xAC77C0F0, 0x330A4405, 0x1B4421C2, 0x8CD38CF6, 0x02A77231, 
  0xA4015240, 0x84736221, 0xC2F5F63D, 0xAD6E7921, 0x3EBA3C4A, 
  0xB3C36A3D, 0x3BB866AD, 0xAF000D9F, 0x2668790D, 0x6A1B361D, 
  0x74F33613, 0x92876C7D, 0x6D2DC516, 0x4561E060, 0x63D8827F, 
  0x62D50248, 0x52228D64, 0x32196C01, 0xD6B978A3, 0x21C800A7, 
  0xFDC809B6, 0x2D0A2D8A, 0xEDCCED68, 0x5A00ED88, 0xB82D50CD, 
  0x96CD86ED, 0xAA1DEAC1, 0x9CFB0CCD, 0x0510FDB0, 0xBF4D0000, 
  0x62D52454, 0x74025588, 0x6773B6F3, 0x4306543D, 0x022B75CE, 
  0xBB4EA8D5, 0xCED96E76, 0x6C070E01, 0xE0ADE0D3, 0xC1D8415A, 
  0x1140C1C8, 0x003651CE, 0xD0C90A35, 0x15D0C933, 0xC5BCB877, 
  0xB990115C, 0x28410604, 0x20C91641, 0x416281D6, 0x63F2211C, 
  0x30B58400, 0x184728E5, 0x28817AAB, 0x06DDE6C7, 0x310A4443, 
  0x2F79F12A, 0x00B5BCF2, 0x606916D3, 0x4A5D6E51, 0x4128ED14, 
  0x00442B27, 0x1A8290A7, 0xBD5BC409, 0xEC3BAD15, 0x21A40178, 
  0x08E10415, 0x9F63F172, 0x40890AE8, 0x2CFD1D11, 0x458225FB, 
  0xEDBBC6AA, 0x7D11FA58, 0x4078B9ED, 0x1170F706, 0x11749DBA, 
  0x6384F3BA, 0x50322773, 0xB5C20368, 0xFDCFE7A2, 0xC9AA45C6, 
  0xFE1CFD4B, 0x16F0F0FD, 0x026D2A00, 0xD70E83DC, 0x7A61B228, 
  0x74D14689, 0xCD2A9071, 0xD4C5BC06, 0xB584456A, 0x53001304, 
  0x0058B083, 0x00130315, 0x0B00713F, 0xB1840013, 0x48041388, 
  0x08C3BC31, 0xE0CB0D41, 0x2DBC0190, 0x00D79D86, 0xAA45AA00, 
  0x00FDEFCA, 0x028F8009, 0x81D21156, 0x311C079A, 0x0DB429FA, 
  0x30950E79, 0xF54A002A, 0xBC1178C0, 0x083178C5, 0x41564162, 
  0x6513BDDE, 0x0E153802, 0x2C1D42D7, 0x17841D79, 0x693E011E, 
  0xB20DD7CC, 0xA2BE101D, 0xFD02EDF2, 0x171DF912, 0x947766A4, 
  0xD1548401, 0x8F2D9342, 0x0285AA62, 0x1AE5A2D3, 0xD4766700, 
  0x5CA19C11, 0xDEE36E13, 0xA2250865, 0x917208E5, 0x2D561DF8, 
  0xB2649F0E, 0x14632E75, 0x271441C5, 0xDCA9CC32, 0x1CE93C17, 
  0xAA456AF1, 0x1DA3CD81, 0x17DC90E7, 0xFD6E4B4C, 0x900F71BE, 
  0x83A28AB9, 0x033881F8, 0x501DB867, 0x4522863C, 0x2DE3CFAA, 
  0xA63B3D7E, 0xF4100F23, 0x891210C1, 0xC1D6513A, 0xDD74B1AC, 
  0xDE9D8452, 0x05A61C51, 0x0073C192, 0x28B2EF10, 0xA8856063, 
  0x67EC61E0, 0x45E0A3BE, 0x3D6FD6AA, 0x7F190500, 0xC27746A8, 
  0x51DE8112, 0x0116711E, 0x62E36D09, 0x277337A4, 0x8C4C374D, 
  0x84D102B1, 0x51F0D70E, 0x3260611E, 0x9ED12273, 0x1B1247E1, 
  0x80496554, 0x23209598, 0xBC230880, 0xA50E0AC3, 0x7970E910, 
  0xB1B25297, 0xA30E79F2, 0xFDFD1C00, 0x20726F47 };
#endif
 
 
#endif
